# -*- coding: utf-8 -*-

"""
spotifywebapiwithfixesandimprovementsfromsonallux

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from spotifywebapiwithfixesandimprovementsfromsonallux.api_helper import APIHelper
from spotifywebapiwithfixesandimprovementsfromsonallux.models.external_url_object import ExternalUrlObject


class ContextObject(object):

    """Implementation of the 'ContextObject' model.

    Attributes:
        mtype (str): The object type, e.g. "artist", "playlist", "album",
            "show".
        href (str): A link to the Web API endpoint providing full details of
            the track.
        external_urls (ExternalUrlObject): External URLs for this context.
        uri (str): The [Spotify
            URI](/documentation/web-api/concepts/spotify-uris-ids) for the
            context.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "mtype": 'type',
        "href": 'href',
        "external_urls": 'external_urls',
        "uri": 'uri'
    }

    _optionals = [
        'mtype',
        'href',
        'external_urls',
        'uri',
    ]

    def __init__(self,
                 mtype=APIHelper.SKIP,
                 href=APIHelper.SKIP,
                 external_urls=APIHelper.SKIP,
                 uri=APIHelper.SKIP):
        """Constructor for the ContextObject class"""

        # Initialize members of the class
        if mtype is not APIHelper.SKIP:
            self.mtype = mtype 
        if href is not APIHelper.SKIP:
            self.href = href 
        if external_urls is not APIHelper.SKIP:
            self.external_urls = external_urls 
        if uri is not APIHelper.SKIP:
            self.uri = uri 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        mtype = dictionary.get("type") if dictionary.get("type") else APIHelper.SKIP
        href = dictionary.get("href") if dictionary.get("href") else APIHelper.SKIP
        external_urls = ExternalUrlObject.from_dictionary(dictionary.get('external_urls')) if 'external_urls' in dictionary.keys() else APIHelper.SKIP
        uri = dictionary.get("uri") if dictionary.get("uri") else APIHelper.SKIP
        # Return an object of this model
        return cls(mtype,
                   href,
                   external_urls,
                   uri)

    @classmethod
    def validate(cls, dictionary):
        """Validates dictionary against class required properties

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            boolean : if dictionary is valid contains required properties.

        """

        if isinstance(dictionary, cls):
            return True

        if not isinstance(dictionary, dict):
            return False

        return True

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'mtype={(self.mtype if hasattr(self, "mtype") else None)!r}, '
                f'href={(self.href if hasattr(self, "href") else None)!r}, '
                f'external_urls={(self.external_urls if hasattr(self, "external_urls") else None)!r}, '
                f'uri={(self.uri if hasattr(self, "uri") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'mtype={(self.mtype if hasattr(self, "mtype") else None)!s}, '
                f'href={(self.href if hasattr(self, "href") else None)!s}, '
                f'external_urls={(self.external_urls if hasattr(self, "external_urls") else None)!s}, '
                f'uri={(self.uri if hasattr(self, "uri") else None)!s})')
